# Debugging level, 0=errors only, 1=return status, init messages,
#   2=smtp server communication, 3=detailed smtp server communication,
#   4=tracebacks, 5=smtp client communication
#   Do not use debug level higher than 9!
DEBUG_LEVEL=3

# Where is new root path. For example '/var/spool/vscan'
CHROOT='/var/spool/vscan'

# Logfile (use logfile in chroot to allow rotating)
LOGFILE=CHROOT+'/var/log/sagator/sagator.log'

# User and group, under which this program runs.
USER,GROUP='vscan','vscan'

# listen host and port
BIND_ADDR=('127.0.0.1',27)

# SMTP server host and port. You must define this smtp server
# in postfix without filtering.
SMTP_SERVER=('127.0.0.1',26)

# statistics collector
COLLECTOR_SERVER=('0.0.0.0',28)

# Scanners
from scanners import *

DROP='(worm|@mm|Sobig|Klez|Bugbear|Gibe|Swen|Mimail|Sober|Bagle|Mydoom|Novarg)'

# Define scanners
SCANNERS=[
  status("Virus",
    report(['root@localhost'],report.MSG_TMPL,
      quarantine('/tmp/quarantine','',
        drop(DROP,
          # ClamAV
          #alternatives(
            #stream2mbox(libclam()),
            #mimeparse(libclam()),
            #mimeparse(stream2file(decompress(libclam()))),
            #clamd(['localhost',3310]),
            clamd('/var/run/clamav/clamd.sock'),
            #stream2mbox(clamscan(['/usr/bin/clamscan','--stdout','--infected','--disable-summary','-r','--mbox'])),
          #),
          # Simple scanners
          #max_file_size(10),
          #mimeparse(file_type({'exe': 'Executable'})),
          #string_scan(VIR_PATTERNS),
          #regexp_scan({'virname':['___PATTERN___']}),
          #mime_ext(mime_ext.EXECUTABLES),
          # AVG7 for linux
          #mimeparse(s2f(avg(chroot=CHROOT))),
          # Bitdefender bdc
          #s2f(bdc()),
          # NODOLD
          #mimeparse(stream2file(decompress(nodold(['localhost',8448])))),
          # Sophie
          #mimeparse(s2f(decompress(sophie('/tmp/sophie',CHROOT)))),
          # exec any program
          #s2f(exec_any(['/bin/grep','-q','^TVqQ'],[1],[0])),
        )
      )
    )
  ),
  status("Spam",
    quarantine('/tmp/quarantine','',
      drop('.', # drop all spams
        # SpamAssassin
        #alternatives(
          spamassassind(['localhost',783]),
        #  spamassassin(['/usr/bin/spamassassin','-e'])
        #),
        #bogofilter(['/usr/bin/bogofilter','-v']),
        #qsf(['/usr/bin/qsf','-r']),
      )
    )
  )
]
