'''
rblcheck module, version 0.1

(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
                                                                                
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

RBL tester.
Based on Gil Gonzales's rbl-check python script.
'''

from avlib import *
import string,re,socket

__all__=['rblcheck','rbls']

rbls=['sbl.spamhaus.org','list.dsbl.org','bl.spamcop.net']

def ip_ok(x):
    octets = string.split(x, '.')
    if len(octets) != 4:
        return 0
    for o in octets:
        try:
            o = int(o)
        except ValueError:
            return 0
        if not (0 <= o < 256):
            return 0
    if octets[0] == '10':
        return 0
    if octets[0] == '172' and octets[1] == '16':
        return 0
    if octets[0] == '192' and octets[1] == '168':
        return 0
    return 1

def parse_received(l):
    mo = re.match(
        r'''
        from\s+
        (?:
          (\S+)\s+ # hostname + trailing space
          \(       # opening bracket
          (?:\S+\s+)?# maybe hostname and space
        )?
        (?:[\d\w:]+@)?\[(\d+.\d+.\d+.\d+)\]
        ''',
        string.join(string.split(l)), re.IGNORECASE | re.VERBOSE)
    if mo and ip_ok(mo.group(2)):
        return mo.groups()
    else:
        return (None, None)

class rblcheck(ascanner):
  '''
  rblcheck scanner - spam ip test in RBL databases
  
  Usage: rblcheck([rbls])
  
  Where: rbls is an array of strings ... rbl checkers

  This scanner scans for spammer domains. If a spam is returned,
  return string is: "RBL:rblserver:return".
  '''
  is_spamscan=1
  name='rblcheck()'
  def __init__(self,lrbls=rbls):
      self.rbls=lrbls
  def scanstream(self,stream):
      return '',[]

raise "This module is not finished."
